
def binary_search(nums, target):
    """
    Do a binary search
    Nums is sorted array
    Return -1 if it fails

    Solved - feels like it could be cleaner,
     - didn't use template for binary search algorithm

    From GeeksForGeeks (afterwards)

    low = 0
    high = len(arr) - 1
    mid = 0

    while low <= high:
        mid = (high + low) // 2
        # If x is greater, ignore left half
        if arr[mid] < x:
            low = mid + 1
        # If x is smaller, ignore right half
        elif arr[mid] > x:
            high = mid - 1
        # means x is present at mid
        else:
            return mid

    # If we reach here, then the element was not present
    return -1
    """
    import math
    # Check if outside range right away
    if target > nums[-1] or target < nums[0]:
        return -1
    # Edge case, single element array
    if len(nums) == 1:
        if nums[0] == target:
            return 0
        else:
            return -1
    # ceil because of how Python does slices
    mid_ind = int(math.ceil(len(nums)/2))
    rem = len(nums)
    while rem > 1:
        mid_val = nums[mid_ind]
        rem = math.ceil(rem / 2)
        if target == mid_val:
            return mid_ind
        if target > mid_val:
            mid_ind = mid_ind + math.floor(rem/2)
            # If only one left check the other element
            if rem == 1 and nums[mid_ind+1] == target:
                return mid_ind + 1
        elif target < mid_val:
            mid_ind = mid_ind - math.ceil(rem/2)
            # If only one left check the other element
            if rem == 1 and nums[mid_ind-1] == target:
                return mid_ind - 1
    if nums[mid_ind] == target:
        return mid_ind
    else:
        return -1


if __name__ == "__main__":
    assert binary_search([5], 5) == 0
    assert binary_search([-1,0,3,5,9,12], 3) == 2
    assert binary_search([-1,0,3,5,9,12], 9) == 4
    assert binary_search([-1,0,3,5,9,12], 2) == -1
    ## Edge of array cases
    assert binary_search([-1,0,3,5,9,12], -1) == 0
    assert binary_search([-1,0,3,5,9,12], 12) == 5

    input_ = [-999,-998,-995,-994,-993,-988,-987,-986,-985,-984,-983,-980,-979,-978,-976,-972,-970,-969,-968,-967,-966,-965,-964,-961,-953,-952,-951,-950,-948,-945,-944,-942,-941,-937,-936,-934,-933,-931,-927,-921,-919,-915,-914,-913,-911,-910,-909,-908,-907,-906,-904,-902,-900,-898,-897,-890,-889,-886,-883,-875,-867,-866,-865,-864,-863,-858,-857,-856,-855,-854,-853,-848,-847,-846,-845,-843,-842,-840,-839,-837,-835,-834,-833,-830,-829,-828,-825,-823,-820,-819,-816,-809,-808,-805,-804,-803,-801,-800,-799,-797,-795,-792,-791,-790,-789,-786,-785,-782,-781,-779,-778,-777,-776,-775,-773,-771,-766,-763,-761,-759,-757,-756,-755,-754,-752,-751,-750,-747,-746,-737,-735,-734,-730,-729,-728,-726,-725,-724,-721,-719,-718,-715,-714,-713,-712,-711,-710,-709,-706,-705,-704,-702,-696,-692,-689,-688,-685,-684,-677,-676,-675,-674,-672,-669,-668,-667,-666,-664,-661,-660,-656,-655,-653,-650,-648,-647,-645,-640,-639,-637,-636,-635,-634,-633,-632,-630,-629,-624,-623,-622,-621,-618,-617,-612,-611,-610,-608,-607,-605,-604,-602,-600,-599,-597,-593,-591,-590,-588,-587,-586,-585,-583,-582,-581,-580,-579,-576,-575,-573,-572,-570,-567,-565,-561,-559,-558,-556,-554,-549,-548,-545,-543,-542,-541,-539,-538,-535,-532,-529,-527,-526,-525,-524,-523,-522,-521,-519,-517,-516,-515,-514,-512,-509,-508,-507,-505,-504,-503,-500,-499,-498,-495,-493,-492,-491,-490,-489,-487,-486,-485,-480,-479,-478,-477,-474,-472,-471,-470,-469,-468,-467,-466,-465,-462,-460,-459,-456,-455,-450,-449,-445,-443,-442,-441,-439,-438,-436,-435,-434,-433,-431,-429,-428,-426,-425,-424,-423,-421,-420,-416,-413,-408,-405,-402,-401,-398,-395,-393,-392,-390,-389,-388,-384,-383,-381,-379,-377,-376,-375,-374,-372,-371,-369,-368,-364,-363,-362,-360,-359,-357,-356,-355,-353,-350,-347,-346,-343,-342,-338,-337,-336,-334,-333,-329,-328,-325,-323,-320,-319,-316,-314,-311,-309,-305,-302,-301,-297,-296,-295,-293,-292,-290,-288,-285,-284,-283,-282,-281,-279,-277,-275,-271,-266,-265,-257,-256,-254,-251,-250,-247,-244,-243,-242,-241,-239,-236,-235,-234,-233,-231,-230,-225,-224,-223,-221,-217,-215,-214,-212,-206,-204,-199,-198,-197,-194,-192,-191,-188,-185,-184,-180,-178,-175,-174,-164,-159,-158,-157,-156,-155,-152,-150,-145,-144,-142,-140,-139,-135,-131,-130,-129,-128,-126,-125,-124,-122,-120,-119,-117,-115,-112,-111,-110,-109,-107,-105,-104,-102,-99,-98,-96,-91,-90,-89,-88,-84,-82,-78,-74,-72,-70,-69,-67,-66,-65,-60,-58,-54,-52,-50,-49,-48,-46,-45,-44,-42,-40,-39,-38,-37,-34,-32,-30,-28,-26,-24,-23,-22,-13,-11,-10,-7,-6,-3,0,1,3,4,5,6,8,9,19,25,26,27,28,29,30,31,32,34,35,36,37,38,39,40,41,43,46,48,50,51,52,53,54,55,56,57,59,60,61,63,65,71,72,74,76,77,78,80,81,82,84,85,87,89,90,91,92,93,94,99,103,106,107,108,110,115,116,120,121,123,124,126,128,129,133,135,137,139,142,143,145,150,152,155,157,159,162,163,165,171,173,174,177,178,182,183,185,188,191,192,193,194,195,196,198,199,201,207,210,211,212,214,216,218,219,221,222,225,226,227,230,231,232,233,234,236,237,241,242,243,244,247,248,249,252,253,254,255,256,259,260,263,264,266,268,270,271,274,275,276,278,281,283,284,286,287,290,292,293,298,302,303,307,309,312,313,316,319,320,323,324,325,327,328,329,330,333,336,337,338,341,343,346,347,348,352,355,358,362,364,370,376,380,381,382,383,384,386,387,390,391,393,398,399,400,405,411,412,417,422,424,427,429,430,432,433,434,437,438,441,444,451,452,454,456,462,463,466,467,471,472,474,479,482,483,486,487,488,489,490,491,492,494,497,502,506,509,510,511,512,517,518,519,522,523,524,525,528,529,530,535,536,537,538,539,541,542,543,544,547,548,550,551,553,554,555,557,558,559,560,562,564,571,572,573,578,581,584,585,586,587,588,589,590,598,600,601,602,603,604,612,613,615,616,617,618,622,625,627,629,633,635,636,637,639,641,642,643,644,645,646,647,649,650,652,653,657,661,662,664,667,669,670,671,674,675,676,682,683,686,687,688,689,693,697,698,699,704,705,707,708,709,711,713,716,719,721,724,725,727,728,729,731,735,736,738,739,740,741,742,744,745,747,752,753,754,755,757,760,764,766,767,768,769,772,773,780,781,783,784,785,786,789,790,797,798,801,802,803,804,805,806,808,810,812,814,816,817,818,821,822,823,824,826,827,828,829,831,832,833,835,840,842,843,844,845,846,848,850,852,853,854,855,857,861,863,867,868,870,875,877,879,880,883,887,888,889,891,893,895,900,901,907,909,910,911,912,913,914,916,917,921,922,926,928,929,930,931,932,933,934,935,937,938,939,942,944,945,946,947,948,949,953,954,957,959,960,962,966,967,972,976,982,988,991,996]
    assert binary_search(input_, -217) == 405
